/* DSP LABORATORY 
 * University of Technology Graz, 2018
 * Josef Kulmer
 */

#ifndef BIQUADCHAIN_H
#define BIQUADCHAIN_H
#include "Biquadfilter.h"
#include <vector>

class BiquadChain {
private:
    std::vector<Biquadfilter> biquads; // stores biquad objects
    std::vector<float> bufferin;    // store signal between the biquad elements
    std::vector<float> bufferout;   // store signal between the biquad elements
    int NBIQUAD;
    float gain;
public:
    // constructor, allocate space
    BiquadChain();
    ~BiquadChain();
    // set coefficients for all biquads
    void setCoefficients(const void *, const int);
    // perform filtering using the biquad chain
    void doFiltering(const void *, void *);
};

#endif /* BIQUADCHAIN_H */

