/* DSP LABORATORY 
 * University of Technology Graz, 2018
 * Josef Kulmer
 * 
 * A Biquad filter performs the filtering of a provided input signal. Its
 * coefficients are stored internally.
 */

#include <iostream>
#include "blockprocessing.h"
#include "Biquadfilter.h"

Biquadfilter::Biquadfilter() {
    bufferin.resize(NBIBUF);
    bufferout.resize(NBIBUF);
};

Biquadfilter::~Biquadfilter(){
}

void Biquadfilter::setCoefficients(const void *coeff) {
    // extract coefficients and consider sign
    float *c = (float*) coeff;
    a1 = *c++;
    a2 = *c++;
    b1 = *c++;
    b2 = *c++;
    b0 = 1; // attenzione: b0 and a0 are assumed to be 1!
    a0 = 1;
};

void Biquadfilter::getCoefficients() {
    std::cout << b0 << b1 << b2 << a0 << a1 << a2;
}

void Biquadfilter::doFiltering(const void *in, void *out) {
    float *input = (float*) in;
    float *output = (float*) out;

    // first element
    *output++ = (b0 * (*input++) + b1 * bufferin[0] + b2 * bufferin[1] + a1 * bufferout[0] + a2 * bufferout[1])/a0;
    // second element
    *output++ = (b0 * (*input) + b1 * (*(input-1)) + b2 * bufferin[0] + a1 * (*(output-1)) + a2 * bufferout[0])/a0;
    // for all other elements
    for (int i = 2; i < FRAMELENGTH; i++) {
        input++;
        *output++ = (b0 * (*input) + b1 * (*(input-1)) + b2 * (*(input-2)) + a1 * (*(output-1)) + a2 * (*(output-2)))/a0;
    }
    // finally save last samples
    bufferin[0]=*input;
    bufferin[1]=*(input-1);
    bufferout[0]=*(output-1);
    bufferout[1]=*(output-2);
}

