/* DSP LABORATORY 
 * University of Technology Graz, 2018
 * Josef Kulmer
 */

#ifndef BIQUADFILTER_H
#define BIQUADFILTER_H

#include <vector>

const int NBIBUF = 2; // Buffer size = 2 for biquad filter
const int NBICOEFF = 4; // expect in total four parameters, b0 and a0 are set to be one!

using std::vector;

class Biquadfilter{
private:
    vector<float> bufferin; // internal buffer
    vector<float> bufferout;
    float a0; // the coefficients
    float a1;
    float a2;
    float b0;
    float b1;
    float b2;
public:
    // constructor
    Biquadfilter();
    ~Biquadfilter();
    // set coefficients
    void setCoefficients(const void *);
    // return coefficients
    void getCoefficients();
    // perform filtering
    void doFiltering(const void *, void *);
};

#endif /* BIQUADFILTER_H */

