/* DSP LABORATORY 
 * University of Technology Graz, 2018
 * Josef Kulmer
 */

#ifndef FIRFILTER_H
#define FIRFILTER_H

#include <vector>
#include <math.h>

using std::vector;

class FIRfilter{
private:
    vector<float> coefficients;
    vector<float> buffer;
    int NFIR;
    int NFIRBUF;
public:
    FIRfilter();
    ~FIRfilter();
    //set internal coefficients
    void setCoefficients(const float [], const int);
    //perform FIR filtering where the multiplications and additions are done in 32bit
    void doFiltering(const void *, void *, unsigned long); 
};

#endif /* FIRFILTER_H */

